/**
 */
package org.eclipse.skills.model.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.eclipse.skills.model.util.SkillsAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class SkillsItemProviderAdapterFactory extends SkillsAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SkillsItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ITask} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TaskItemProvider taskItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ITask}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTaskAdapter() {
		if (taskItemProvider == null) {
			taskItemProvider = new TaskItemProvider(this);
		}

		return taskItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IDescription} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DescriptionItemProvider descriptionItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IDescription}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDescriptionAdapter() {
		if (descriptionItemProvider == null) {
			descriptionItemProvider = new DescriptionItemProvider(this);
		}

		return descriptionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IBadge} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BadgeItemProvider badgeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IBadge}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBadgeAdapter() {
		if (badgeItemProvider == null) {
			badgeItemProvider = new BadgeItemProvider(this);
		}

		return badgeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IUser} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UserItemProvider userItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IUser}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUserAdapter() {
		if (userItemProvider == null) {
			userItemProvider = new UserItemProvider(this);
		}

		return userItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ISkill} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SkillItemProvider skillItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ISkill}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSkillAdapter() {
		if (skillItemProvider == null) {
			skillItemProvider = new SkillItemProvider(this);
		}

		return skillItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IUserTask} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UserTaskItemProvider userTaskItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IUserTask}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUserTaskAdapter() {
		if (userTaskItemProvider == null) {
			userTaskItemProvider = new UserTaskItemProvider(this);
		}

		return userTaskItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IQuest} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected QuestItemProvider questItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IQuest}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createQuestAdapter() {
		if (questItemProvider == null) {
			questItemProvider = new QuestItemProvider(this);
		}

		return questItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IBadgeReward} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BadgeRewardItemProvider badgeRewardItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IBadgeReward}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBadgeRewardAdapter() {
		if (badgeRewardItemProvider == null) {
			badgeRewardItemProvider = new BadgeRewardItemProvider(this);
		}

		return badgeRewardItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IExperienceReward} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExperienceRewardItemProvider experienceRewardItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IExperienceReward}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExperienceRewardAdapter() {
		if (experienceRewardItemProvider == null) {
			experienceRewardItemProvider = new ExperienceRewardItemProvider(this);
		}

		return experienceRewardItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ISkillReward} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SkillRewardItemProvider skillRewardItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ISkillReward}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSkillRewardAdapter() {
		if (skillRewardItemProvider == null) {
			skillRewardItemProvider = new SkillRewardItemProvider(this);
		}

		return skillRewardItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IAndDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AndDependencyItemProvider andDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IAndDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAndDependencyAdapter() {
		if (andDependencyItemProvider == null) {
			andDependencyItemProvider = new AndDependencyItemProvider(this);
		}

		return andDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IOrDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OrDependencyItemProvider orDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IOrDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOrDependencyAdapter() {
		if (orDependencyItemProvider == null) {
			orDependencyItemProvider = new OrDependencyItemProvider(this);
		}

		return orDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.INotDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NotDependencyItemProvider notDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.INotDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNotDependencyAdapter() {
		if (notDependencyItemProvider == null) {
			notDependencyItemProvider = new NotDependencyItemProvider(this);
		}

		return notDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IDelayedDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DelayedDependencyItemProvider delayedDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IDelayedDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDelayedDependencyAdapter() {
		if (delayedDependencyItemProvider == null) {
			delayedDependencyItemProvider = new DelayedDependencyItemProvider(this);
		}

		return delayedDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ICustomDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CustomDependencyItemProvider customDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ICustomDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCustomDependencyAdapter() {
		if (customDependencyItemProvider == null) {
			customDependencyItemProvider = new CustomDependencyItemProvider(this);
		}

		return customDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ISequenceDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SequenceDependencyItemProvider sequenceDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ISequenceDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSequenceDependencyAdapter() {
		if (sequenceDependencyItemProvider == null) {
			sequenceDependencyItemProvider = new SequenceDependencyItemProvider(this);
		}

		return sequenceDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ICompleteIncludedTasksDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CompleteIncludedTasksDependencyItemProvider completeIncludedTasksDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ICompleteIncludedTasksDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCompleteIncludedTasksDependencyAdapter() {
		if (completeIncludedTasksDependencyItemProvider == null) {
			completeIncludedTasksDependencyItemProvider = new CompleteIncludedTasksDependencyItemProvider(this);
		}

		return completeIncludedTasksDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ITaskDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TaskDependencyItemProvider taskDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ITaskDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTaskDependencyAdapter() {
		if (taskDependencyItemProvider == null) {
			taskDependencyItemProvider = new TaskDependencyItemProvider(this);
		}

		return taskDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.ISkillDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SkillDependencyItemProvider skillDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.ISkillDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSkillDependencyAdapter() {
		if (skillDependencyItemProvider == null) {
			skillDependencyItemProvider = new SkillDependencyItemProvider(this);
		}

		return skillDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IHint} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HintItemProvider hintItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IHint}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHintAdapter() {
		if (hintItemProvider == null) {
			hintItemProvider = new HintItemProvider(this);
		}

		return hintItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IFactorProgression} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FactorProgressionItemProvider factorProgressionItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IFactorProgression}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFactorProgressionAdapter() {
		if (factorProgressionItemProvider == null) {
			factorProgressionItemProvider = new FactorProgressionItemProvider(this);
		}

		return factorProgressionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.skills.model.IUserTitle} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UserTitleItemProvider userTitleItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.skills.model.IUserTitle}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUserTitleAdapter() {
		if (userTitleItemProvider == null) {
			userTitleItemProvider = new UserTitleItemProvider(this);
		}

		return userTitleItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void dispose() {
		if (taskItemProvider != null) taskItemProvider.dispose();
		if (descriptionItemProvider != null) descriptionItemProvider.dispose();
		if (badgeItemProvider != null) badgeItemProvider.dispose();
		if (userItemProvider != null) userItemProvider.dispose();
		if (skillItemProvider != null) skillItemProvider.dispose();
		if (userTaskItemProvider != null) userTaskItemProvider.dispose();
		if (questItemProvider != null) questItemProvider.dispose();
		if (badgeRewardItemProvider != null) badgeRewardItemProvider.dispose();
		if (experienceRewardItemProvider != null) experienceRewardItemProvider.dispose();
		if (skillRewardItemProvider != null) skillRewardItemProvider.dispose();
		if (andDependencyItemProvider != null) andDependencyItemProvider.dispose();
		if (orDependencyItemProvider != null) orDependencyItemProvider.dispose();
		if (notDependencyItemProvider != null) notDependencyItemProvider.dispose();
		if (delayedDependencyItemProvider != null) delayedDependencyItemProvider.dispose();
		if (customDependencyItemProvider != null) customDependencyItemProvider.dispose();
		if (sequenceDependencyItemProvider != null) sequenceDependencyItemProvider.dispose();
		if (completeIncludedTasksDependencyItemProvider != null) completeIncludedTasksDependencyItemProvider.dispose();
		if (taskDependencyItemProvider != null) taskDependencyItemProvider.dispose();
		if (skillDependencyItemProvider != null) skillDependencyItemProvider.dispose();
		if (hintItemProvider != null) hintItemProvider.dispose();
		if (factorProgressionItemProvider != null) factorProgressionItemProvider.dispose();
		if (userTitleItemProvider != null) userTitleItemProvider.dispose();
	}

}
